#!/usr/bin/php -q
<?php /* Copyright (C) 2015 G.Paolo Bizzaro */

function PrintColor($String,$fgColor=7,$bgColor=0,$Bold=FALSE)
{
  print "\033[3${fgColor};4${bgColor}m" . ($Bold?"\033[1m":'') . $String . "\033[0m" ;
}

function Led($numero,$colore)
{
  global $fMidi ;
  fwrite ( $fMidi , chr(144).chr($numero).chr($colore) ); fflush($fMidi);
  usleep(10);
}

function ProcessStart($cmdline) // return pid
{
  exec( "nohup $cmdline >/dev/null 2>&1 & echo $!", $output) ;
  // print_r ($output);
  return (int)$output[0];
}

function ProcessStatus($pid) // return TRUE (live) o FALSE (dead)
{
   exec("ps -p $pid",$output);
   // print_r($output);
   return ( isset($output[1]) ? TRUE : FALSE ) ;
}

function ProcessStop($pid)
{
   exec("kill $pid",$output); // kill -9 ??
}

function ReadSndCfg($filename)
{
  $Aresult = array();
  if ($ACfg = @file($filename))
  {
    foreach($ACfg as $key => $val)
    {
      $ArrayLinea = explode(',',$val.',,,,,,,');
      $blocco    = 0+(int)$ArrayLinea[0] ;
      $numero    = 0+(int)$ArrayLinea[1] ;
      $file      = trim($ArrayLinea[2]) ;
      $type      = 'N' ; // normal
      if ( ($blocco>0) && ($numero>0) && strlen($file)>0 && is_file($file) )
      {
        $Aresult[$blocco][$numero]['file']   = $file;
        $Aresult[$blocco][$numero]['type']   = 'N'; // normal
        $Aresult[$blocco][$numero]['pid']    = 0 ;
      }
    }
  }
  return $Aresult ;
}

/*
 56 57 58 59 60 61 62 63  82
 48 49 50 51 52 53 54 55  83
 40 41 42 43 44 45 46 47  84
 32 33 34 35 36 37 38 39  85
 24 25 26 27 28 29 30 31  86
 16 17 18 19 20 21 22 23  87
  8  9 10 11 12 13 14 15  88
  0  1  2  3  4  5  6  7  89

 64 65 66 67 68 69 70 71  98

Per farli colorare inviare 144-X-C con X posizione tasto e C colore:
 0: spento
 1: verde fisso
 2: verde lampeggiante
 3: rosso fisso
 4: rosso lampeggiante
 5: giallo fisso
 6: giallo lampeggiante
 dal 7 in poi è sempre verde fisso
 i pulsanti in basso 64-71 da 1 in poi sono sempre rossi,
 i pulsanti a destra 82-89 da 1 in poi sono sempre verdi,
 il pulsante in basso a destra 98 è sempre spento.

 I 9 potenziometri emettono 176-Y-Z con Y da 48 a 56 e Z da 0 a 127 secondo la posizione
*/

//******************************************************************************

  $LedOFF    = 0 ;
  $LedGREEN  = 1 ; // 1 normale (2 lampeggiante inutilizzato) => suono a disposizione
  $LedRED    = 3 ; // 3 normale (4 lampeggiante inutilizzato) => suono in esecuzione in modalità normale
  $LedYELLOW = 5 ; // 5 normale (6 lampeggiante inutilizzato) => suono in esecuzione in modalità loop

  $LedStart = array ( 0=>5, 1=>3, 2=>1, 3=>5, 4=>3, 5=>1, 6=>5, 7=>3,
                      8=>1, 9=>5,10=>3,11=>1,12=>5,13=>3,14=>1,15=>5,
                     16=>3,17=>1,18=>5,19=>3,20=>1,21=>5,22=>3,23=>1,
                     24=>5,25=>3,26=>1,27=>5,28=>3,29=>1,30=>5,31=>3,
                     32=>1,33=>5,34=>3,35=>1,36=>5,37=>3,38=>1,39=>5,
                     40=>3,41=>1,42=>5,43=>3,44=>1,45=>5,46=>3,47=>1,
                     48=>5,49=>3,50=>1,51=>5,52=>3,53=>1,54=>5,55=>3,
                     56=>1,57=>5,58=>3,59=>1,60=>5,61=>3,62=>1,63=>5,

                     64=>0,65=>0,66=>0,67=>0,68=>0,69=>0,70=>0,71=>0, // pulsanti sottostanti tutti spenti
                     82=>1,83=>0,84=>0,85=>0,86=>0,87=>0,88=>0,89=>1, ) ; // pulsanti a destra accesi solo primo e ultimo

  // rilevo device guardando in /proc/asound/card*/usbid se usbid=identificativo
  $myMidi='' ;
  exec( "grep -H -i 09E8:0028 /proc/asound/card*/usbid 2>/dev/null", $output) ;
  // output:  /proc/asound/card1/usbid:09e8:0028     (numero "1") =>  /dev/midi1
  if (isset($output[0])) { $AOut = explode(':',$output[0]); $myMidi = '/dev/midi' . (0+(int)substr($AOut[0],17)); }
  if(strlen($myMidi)==0)
  {
    print "Device AKAI APCmini not found. Exit.\n" ;    exit();
  }
  if ($myMidi=='/dev/midi0') $myMidi='/dev/midi' ;
  // /proc/asound/card2/usbid:09e8:0028

  // $myMidi = '/dev/midi2';   # -M dispositivo midi di input
  $myConf = 'PlaySound4.txt';  # -C file configurazione suoni
  $myProg = 'mplayer' ;        # program to play files /bin/mplayer  /bin/play  /bin/smplayer

  PrintColor ("PlaySound by G.Paolo Bizzaro\n",7,0,TRUE);
  print "usage: ".$argv[0]." [options]...\n"
  . "where options (case insensitive) are:\n"
  // . "-Imidi input device (default $myMidi)\n"
  . "-Cconfiguration file (default \"$myConf\")\n"
  . "-Pprogram program to play files (default \"$myProg\", if you want graphic interface you can use /bin/smplayer)\n" ;

  // controlla opzioni
  for ( $i=1 ; $i < $argc ; $i++ )
  {
    if (strlen($argv[$i])>2)
    {
      $argo = substr($argv[$i],2) ;
      $argo2 = substr(strtoupper($argv[$i]),0,2);
      if ($argo2=="-I")  $myMidi = $argo ;
      if ($argo2=="-C")  $myConf = $argo ;
      if ($argo2=="-P")  $myProg = $argo ;
    }
  }

  print "RUN with parameters:\n"
  . "• midi input device: \"$myMidi\"\n"
  . "• configuration file: \"$myConf\"\n" ;

  $SndCfg = ReadSndCfg($myConf);

  flush();

  $ProcessList = array ();

  if(!($fMidi=fopen($myMidi,'r+')))   exit("fopen $myMidi failed\n");

  print "Aperto tutto, via!\n"; flush();

  $Blocco = 0 ;

  foreach ( $LedStart as $iLed => $oLed )
  {
    Led($iLed,$oLed);
  }

  stream_set_blocking ( $fMidi , FALSE ) ;
  $BtnSHIFT = FALSE ;

  set_time_limit(0);
  $Level = 0 ;
  $VolumeLevel = 64 ; $NewVolumeLevel = 63 ; // volume default
  while(TRUE)
  {
      $letto=0;
      $car = fread($fMidi,1);
      if(strlen($car))
      {
        $letto=1;
        $carat = ord($car);
        //print "($carat) " ; flush();

        if ($carat>=128) // carattere di controllo (dovrebbe essere >=128   && in_array($caratlow,$myMidiController)
        {
          $TipoMessaggio   = $carat & 240 ; // 128+64+32+16  16 tipi di messaggio: 144/128 note on/off, 176 potenziometri
          $CanaleMidi      = $carat & 15 ;  // 8+4+2+1       16 canali midi
          $Carat0          = $carat ;
          $Level           = 1 ;
        }

        elseif($Level==1) // è già arrivato un carattere >128, messo in Carat0
        {
          $Carat1 = $carat ;
          $Level++ ;
        }

        elseif($Level==2) // sono già arrivati 2 caratteri, messi in Carat0 e Carat1
        {
          $Carat2 = $carat ;
          $Level++ ;
          // print "($Carat0-$Carat1-$Carat2)" ; flush();
          if ($Carat0==144) // nota on
          {
            if ($Carat1==98) // bottoncino shift
            {
              //Led($Carat1,127);
              $BtnSHIFT = TRUE ;
            }

            elseif ($Carat1==82) // PULSANTE IN ALTO A DESTRA
            {
              if($BtnSHIFT) // se c'è shift acceso
              {

                foreach ( $SndCfg as $iBlocco => $oBlocco )
                {
                  foreach ( $oBlocco as $iSuono => $oSuono )
                  {
                    $pid = $SndCfg[$iBlocco][$iSuono]['pid']; // pid in tabella
                    if ($pid>0)
                    {
                      if (ProcessStatus($pid)) // ancora in esecuzione, dovrei killarlo
                      {
                        $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                        ProcessStop($pid) ;
                        $SndCfg[$iBlocco][$iSuono]['pid']=0;
                        print "KILL [$iBlocco][$iSuono] \"$title\" PID $pid\n" ;
                        // if ( $iBlocco==$Blocco ) Led($iSuono-1,$LedGREEN);
                      }
                      else  // non in esecuzione
                      {
                        $SndCfg[$iBlocco][$iSuono]['pid'] = 0 ;
                        $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                        print "END [$iBlocco][$iSuono] \"$title\" PID $pid\n" ;
                        // print "iBlocco=$iBlocco, Blocco=$Blocco\n" ;
                        // if ( $iBlocco==$Blocco ) Led($iSuono-1,$LedGREEN);
                      }
                    }
                  }
                }

                foreach ( $LedStart as $iLed => $oLed )
                {
                  Led($iLed,0);
                }
                PrintColor("EXIT\n",2,0,TRUE);
                exit();
              }
              else
              {
                PrintColor("KILL ALL\n",2,0,TRUE);

                foreach ( $SndCfg as $iBlocco => $oBlocco )
                {
                  foreach ( $oBlocco as $iSuono => $oSuono )
                  {
                    $pid = $SndCfg[$iBlocco][$iSuono]['pid']; // pid in tabella
                    if ($pid>0)
                    {
                      if (ProcessStatus($pid)) // ancora in esecuzione, dovrei killarlo
                      {
                        $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                        ProcessStop($pid) ;
                        $SndCfg[$iBlocco][$iSuono]['pid']=0;
                        print "KILL [$iBlocco][$iSuono] \"$title\" PID $pid\n" ;
                        if ( $iBlocco==$Blocco ) Led($iSuono-1,$LedGREEN);
                      }
                      else  // non in esecuzione
                      {
                        $SndCfg[$iBlocco][$iSuono]['pid'] = 0 ;
                        $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                        print "END [$iBlocco][$iSuono] \"$title\" PID $pid\n" ;
                        // print "iBlocco=$iBlocco, Blocco=$Blocco\n" ;
                        if ( $iBlocco==$Blocco ) Led($iSuono-1,$LedGREEN);
                      }
                    }
                  }
                }

              }
            }

            elseif ($Carat1==89) // OTTAVO PULSANTE A DESTRA (PRIMO SOPRA SHIFT)
            {
              if($BtnSHIFT) // se c'è shift acceso
              {
              }
              else
              {
                PrintColor("ELENCO PROCESSI IN ESECUZIONE\n",2,0,TRUE);
                foreach ( $SndCfg as $iBlocco => $oBlocco )
                {
                  foreach ( $oBlocco as $iSuono => $oSuono )
                  {
                    $pid = $SndCfg[$iBlocco][$iSuono]['pid']; // pid in tabella
                    if ($pid>0)
                    {
                      $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                      PrintColor("[$iBlocco][$iSuono] \"$title\"\n",3,0,TRUE);
                    }
                  }
                }
              }
            }

            elseif ($Carat1>=64 && $Carat1<=71) // cambio blocco
            {
              $nuovoBlocco = $Carat1-63;  // 1..8
              if ( $nuovoBlocco != $Blocco )
              {
                if ($Blocco>0) // spengo blocco attuale
                {
                  Led($Blocco+63,$LedOFF);
                }
                $Blocco = $nuovoBlocco ;
                Led($Blocco+63,$LedRED);
                PrintColor("BLOCCO [$Blocco]\n",3,0,TRUE);
                for ($p=1;$p<=64;$p++)
                {
                  if(isset($SndCfg[$Blocco][$p]))
                  {
                    $title = $SndCfg[$Blocco][$p]['file'] ;
                    if ($SndCfg[$Blocco][$p]['pid'])
                    {
                      PrintColor("[$Blocco][$p] \"$title\"\n",3,0,TRUE);
                      if ($SndCfg[$Blocco][$p]['type']=='L')
                        Led($p-1,$LedYELLOW);
                      else
                        Led($p-1,$LedRED);
                    }
                    else
                    {
                      PrintColor("[$Blocco][$p] \"$title\"\n",3,0,FALSE);
                      Led($p-1,$LedGREEN);
                    }
                  }
                  else Led($p-1,$LedOFF);
                }
              }
              else // solo stampa elenco
              {
                PrintColor("BLOCCO [$Blocco]\n",3,0,TRUE);
                for ($p=1;$p<=64;$p++)
                {
                  if(isset($SndCfg[$Blocco][$p]))
                  {
                    // print_r($SndCfg[$Blocco][$p]); print "\n";
                    $title = $SndCfg[$Blocco][$p]['file'] ;
                    $bold = $SndCfg[$Blocco][$p]['pid'] > 0 ? TRUE : FALSE ;
                    PrintColor("[$Blocco][$p] \"$title\"\n",3,0,$bold);
                  }
                }
              }
            }

            elseif ($Carat1<64)
            {
              $Suono = $Carat1+1 ; // converto in 1..64

              if(isset($SndCfg[$Blocco][$Suono]))
              {
                if($BtnSHIFT) // se c'è shift acceso
                {
                  $pid = isset($SndCfg[$Blocco][$Suono]['pid']) ? $SndCfg[$Blocco][$Suono]['pid'] : 0 ;
                  if ( $pid>0 ) // processo in esecuzione, swappo Normal/Loop
                  {
                    $title = $SndCfg[$Blocco][$Suono]['file'] ;
                    if ($SndCfg[$Blocco][$Suono]['type']=='L')
                    {
                      $SndCfg[$Blocco][$Suono]['type']='N' ;
                      Led($Carat1,$LedRED);
                      print "LOOP➤NORMAL [$Blocco][$Suono] \"$title\"\n" ;
                    }
                    else
                    {
                      $SndCfg[$Blocco][$Suono]['type']='L' ;
                      Led($Carat1,$LedYELLOW);
                      print "NORMAL➤LOOP [$Blocco][$Suono] \"$title\"\n" ;
                    }
                  }
                  else // avvio processo (modalità Loop)
                  {
                    $title = $SndCfg[$Blocco][$Suono]['file'] ;
                    $SndCfg[$Blocco][$Suono]['type']='L' ;
                    $cmdline = "$myProg 2>/dev/null \"$title\"" ;
                    $pid = ProcessStart($cmdline);
                    $SndCfg[$Blocco][$Suono]['pid'] = $pid;
                    print "START LOOP [$Blocco][$Suono] \"$title\" PID $pid\n" ;
                    Led($Carat1,$LedYELLOW);
                  }
                }
                else // normale senza shift
                {
                  // print "[$Carat1] " ; flush();

                  $pid = isset($SndCfg[$Blocco][$Suono]['pid']) ? $SndCfg[$Blocco][$Suono]['pid'] : 0 ;
                  if ( $pid>0 ) // processo in esecuzione, lo killo
                  {
                    $title = $SndCfg[$Blocco][$Suono]['file'] ;
                    ProcessStop($pid) ;
                    $SndCfg[$Blocco][$Suono]['pid']=0;
                    print "KILL [$Blocco][$Suono] \"$title\" PID $pid\n" ;
                    Led($Carat1,$LedGREEN);
                  }
                  else // non in esecuzione, avvio il processo modalità Normale
                  {
                    $title = $SndCfg[$Blocco][$Suono]['file'] ;
                    $SndCfg[$Blocco][$Suono]['type'] ='N' ;
                    $cmdline = "$myProg 2>/dev/null \"$title\"" ;
                    $pid = ProcessStart($cmdline);
                    $SndCfg[$Blocco][$Suono]['pid'] = $pid;
                    print "START NORMAL [$Blocco][$Suono] \"$title\" PID $pid\n" ;
                    Led($Carat1,$LedRED);
                  }
                }
              }
            }
          }
            //$out = chr($Carat0) . chr($Carat1) . chr($Carat2);
          elseif ($Carat0==128) // nota off
          {
            if ($Carat1==98) // bottoncino shift
            {
              // Led($Carat1,0);
              $BtnSHIFT = FALSE ;
            }
          }
          elseif ($Carat0==176) // potenziometro
          {
            // I 9 potenziometri emettono 176-Y-Z con Y da 48 a 56 e Z da 0 a 127 secondo la posizione
            // amixer sset 'Master' 50%
            if ($Carat1==56) // generale
            {
              $NewVolumeLevel = round ( $Carat2 / 1.27, 0 ) ;
            //  PrintColor("[Vol.$NewVolumeLevel%]\n",4);
            //  exec("amixer sset 'Master' $NewVolumeLevel%", $output) ;
              // PrintColor("[Vol.$level%]\n",4);
            }
            // output inalterato
            //print ">($Carat0-$Carat1-$Carat2) " ; flush();
            // $out = chr($Carat0) . chr($Carat1) . chr($Carat2);
            // fwrite($fMidiOut,$out); fflush($fMidiOut);
          }
          $Level = 0 ;
        }
      } // if car

      // verifica processi in esecuzione

      foreach ( $SndCfg as $iBlocco => $oBlocco )
      {
        foreach ( $oBlocco as $iSuono => $oSuono )
        {
          $pid = $SndCfg[$iBlocco][$iSuono]['pid']; // pid in tabella
          if ($pid>0)
          {
            if (ProcessStatus($pid)) // ancora in esecuzione, non tocco niente
            {
              // if     ( $SndCfg[$iBlocco][$iSuono]['type']=='N' && $StatusCanale[$key]!=$LedRED    ) {} // Led($key,$LedRED);
              // elseif ( $SndCfg[$iBlocco][$iSuono]['type']=='L' && $StatusCanale[$key]!=$LedYELLOW ) {} // Led($key,$LedYELLOW);
            }
            else  // non in esecuzione
            {
              if ( $SndCfg[$iBlocco][$iSuono]['type']=='L') // se è un tipo 'L' (loop) dovrei rilanciarlo
              {
                $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                $cmdline = "$myProg 2>/dev/null \"$title\"" ;
                $pid = ProcessStart($cmdline);
                $SndCfg[$iBlocco][$iSuono]['pid'] = $pid;
                print "LOOP [$iBlocco][$iSuono] \"$title\" PID $pid\n" ;
              // if ( $StatusCanale[$key]!=$LedYELLOW ) Led($key,$LedYELLOW);
              }
              else // normale, finisce processo e se necessario led verde
              {
                $SndCfg[$iBlocco][$iSuono]['pid'] = 0 ;
                $title = $SndCfg[$iBlocco][$iSuono]['file'] ;
                print "END [$iBlocco][$iSuono] \"$title\" PID $pid\n" ;
                // print "iBlocco=$iBlocco, Blocco=$Blocco\n" ;
                if ( $iBlocco==$Blocco ) Led($iSuono-1,$LedGREEN);
              }
            }
          }
        }
      }

      if ($letto==0)
      {
        if ( $VolumeLevel != $NewVolumeLevel )
        {
          PrintColor("[Vol.$NewVolumeLevel%]\n",4);
          exec("amixer sset 'Master' $NewVolumeLevel%", $output) ;
          $VolumeLevel = $NewVolumeLevel ;    
        }
        usleep(10000);
        // print "." ; flush(); */
      }
  }

?>

